<template>

  <q-dialog persistent ref="dialog" @hide="onDialogHide" >
    <q-card>
      <q-card-section class="row items-center">
        <q-avatar icon="far fa-bell" color="primary" text-color="white"/>
        <span class="q-ml-sm">{{message}}</span>
      </q-card-section>

      <q-card-section class="q-pa-md q-mt-md scroll"  v-if="hasResponse"  style="max-height: 70vh">
        <div class="row">
          <div class="col-xs-12 col-sm-12" >
            <MField
              class="col-xs-12 col-sm-6"
              label="Réponse"
              orientation="vertical"
              :main-design="'outlined'"
              :readonly="false"
              :type-input="inputType"
              :hide-bottom-space="true"
              v-model="form.response"
              @m-blur="$v.form.response.$touch"
              :error="$v.form.response.$error"
              error-message="Champs requis"
            />
          </div>
        </div>
      </q-card-section>

      <q-card-actions align="right">
        <q-btn stretch flat label="Annuler" color="primary" @click="onCancelClick" />
        <q-btn stretch flat label="Ok" color="primary" @click="onOKClick"  v-close-popup />
      </q-card-actions>
    </q-card>
  </q-dialog>

</template>

<script>
  import {mapActions, mapState} from 'vuex'
  import {required, requiredIf} from 'vuelidate/lib/validators'
  import MField from "../forms/MField";

  export default {
    name: 'FOptionDialog',
    components: {
      MField,
    },
    props: {
      state: {
        type: String,
        validator: function (value) {
          return ['view', 'create', 'update'].indexOf(value) !== -1
        },
      },
      title: {
        type: String,
      },
      message: {
        type: String,
      },
      optionType: {
        type: String,
        validator: function (value) {
          return ['success', 'warning', 'error'].indexOf(value) !== -1
        },
      },
      hasResponse: {
        type: Boolean,
        default: false
      },
      inputType: {
        type: String,
        validator: function (value) {
          return ['text', 'textarea', 'number', 'date'].indexOf(value) !== -1
        },
      },
    },

    data() {
      return {
        form: {
          ok: true,
          response: '',
        },
      }
    },

    validations: {
      form: {
        response: {
          required: requiredIf(function (value) {
            return this.hasResponse;
          }),
        }
      },
    },

    methods: {
      async submit() {
        this.$v.form.$touch()
        if (this.$v.form.$error) {
          return Promise.reject(new Error('ErrorForm'))
        }
        this.$emit('ok', this.form)
        this.hide()
        return Promise.resolve(this.form)
      },

      show() {
        this.$refs.dialog.show()
      },

      hide() {
        this.$refs.dialog.hide()
      },

      onDialogHide() {
        this.$emit('hide')
      },

      async onOKClick() {
        try {
          await this.submit()
        } catch (e) {
        }
      },

      onCancelClick() {
        // this.$emit('cancel', false)
        this.hide()
      },
    },
    computed: {
      backgroundColor() {
        return this.optionType === 'success' ? 'bg-primary' : this.optionType === 'warning' ? 'bg-orange' : this.optionType === 'error' ? 'bg-red' : '';
      },
      ...mapState({}),
    },
    watch: {},

    mounted() {
    },
  }
</script>
